#!/bin/sh
# Switch to correct shell for platform, and execute setup script
#
# parameters are 
#                1=tmp file dir
#                2=db2 userid 
#                3=db2 password

SCRIPTDIR=$1
DB2USERID=$2
DB2PASSWD=$3

# Immediately log user details                                   
echo DIR ${SCRIPTDIR} USER ${DB2USERID} >> UDDILoadDB.log

# Pick correct platform and launch 2nd script.                              
if [ `uname` = "Linux" ]; then
  sh ${SCRIPTDIR}/LoadDB.sh ${SCRIPTDIR} ${DB2USERID} ${DB2PASSWD} >> UDDILoadDB.log 2>&1 
else 
  ksh ${SCRIPTDIR}/LoadDB.sh ${SCRIPTDIR} ${DB2USERID} ${DB2PASSWD} >> UDDILoadDB.log 2>&1
fi

#generate a return code for caller.
tail -1 UDDILoadDB.log | grep "LoadDB.sh finished with success at" > /dev/null
