#Parameters passed are scriptdir,username,password.

SCRIPTDIR=$1
DB2USERID=$2
DB2PASSWD=$3

echo "populate Category tables called with tmpdir ${SCRIPTDIR} db2userid of ${DB2USERID} at `date`"
DBUSER=${DB2USERID}
DBPWD=${DB2PASSWD}

echo "Connecting to Database"
db2 connect to uddi20 user ${DBUSER} using ${DBPWD} 
if [ $? != 0 ]; then
  echo ERROR: DB2 Failed to connect to database
  exit 1
fi

# Populate the types table
echo db2 import from ${SCRIPTDIR}/udditype-data.txt of del modified by coldel# insert into category
db2 import from ${SCRIPTDIR}/udditype-data.txt of del modified by coldel# insert into category
if [ $? != 0 ]; then
  echo ERROR: DB2 Failed to populate the types table cleanly
#  exit 1
fi

# Populate the NAICS category table.
echo db2 import from ${SCRIPTDIR}/naics-data.txt of del modified by coldel# insert into category
db2 import from ${SCRIPTDIR}/naics-data.txt of del modified by coldel# insert into category
if [ $? != 0 ]; then
  echo ERROR: DB2 Failed to populate the NAICS table cleanly
#  exit 1
fi

# Populate the UNSPSC category table.
echo db2 import from ${SCRIPTDIR}/unspsc-data.txt of del modified by coldel# insert into category
db2 import from ${SCRIPTDIR}/unspsc-data.txt of del modified by coldel# insert into category
if [ $? != 0 ]; then
  echo ERROR: DB2 Failed to populate the UNSPSC table cleanly
#  exit 1
fi

# Populate the GEO category table.
echo db2 import from ${SCRIPTDIR}/geo-data.txt of del modified by coldel# insert into category
db2 import from ${SCRIPTDIR}/geo-data.txt of del modified by coldel# insert into category
RESULT=$?
if [ ${RESULT} != 0 ]; then
  echo ERROR: DB2 Failed to populate the GEO table cleanly ${RESULT}
#  exit 1
fi

# Populate the UNSPSC7 category table.
echo db2 import from ${SCRIPTDIR}/unspsc7-data.txt of del modified by coldel# insert into category
db2 import from ${SCRIPTDIR}/unspsc7-data.txt of del modified by coldel# insert into category
if [ $? != 0 ]; then
  echo ERROR: DB2 Failed to populate the UNSPSC7 table cleanly
#  exit 1
fi

echo "Resetting connection"
db2 connect reset
if [ $? != 0 ]; then
  echo ERROR: DB2 Failed to reset connection
  exit 1
fi

echo "Terminating"
db2 terminate
if [ $? != 0 ]; then
  echo ERROR: DB2 Failed to terminate on request
  exit 1
fi

echo Leaving populateCatTable.sh with success at `date`
