rem parameters are: 1=dir holding scripts 2=db2 userid, 3=db2 password
setlocal

rem first test if there is DB2CODEPAGE set already
db2set DB2CODEPAGE >NUL 2>&1
@if %ERRORLEVEL% == 0 (
  @for /f "tokens=1" %%o in ('db2set DB2CODEPAGE') do (
    @echo "DB2 Codepage is already set to : %%o"
    @if %%o. == 1208. goto POSTCPCHECK
    @if %%o. == UTF-8. goto POSTCPCHECK    
    @echo "Incompatible DB2 Codepage %%o already set"
    @echo "DB2CODEPAGE must be 1208 or UTF-8, ie DB2SET DB2CODEPAGE 1208"
    @goto BADEXIT
  )
)
:POSTCPCHECK

rem Evaluate if we need to set the db2set vars       
for /F "delims== tokens=1" %%v in ('db2set') do (
    if "%%v" == "DB2_INDEX_2BYTEVARLEN" (
	    set INDEX_VAR_ALREADY_SET=true
	) else if "%%v" == "DB2CODEPAGE" (
	    set CODEPAGE_VAR_ALREADY_SET=true
	)
)

set CODEPAGE_VAR_ALREADY_SET=false
for /F "delims== tokens=1" %%v in ('db2set') do (
    if "%%v" == "DB2CODEPAGE" (
	    set CODEPAGE_VAR_ALREADY_SET=true
	)
)

if not "%INDEX_VAR_ALREADY_SET%" == "true" (
    call %1\setDB2ProfileVariables
) else if not "%CODEPAGE_VAR_ALREADY_SET%" == "true" (
    call %1\setDB2ProfileVariables
)

  
rem DROP OLD DATABASE  
  
rem connect reset is just a precaution prior to drop.
db2 connect reset
set RC=%ERRORLEVEL%
echo "Connect reset returned rc: %RC%" 

rem terminate is just a precaution prior to drop.
db2 terminate
set RC=%ERRORLEVEL%
echo "Terminate returned rc: %RC%" 

rem force application all is required for drop to succeed
db2 force application all
set RC=%ERRORLEVEL%
echo "Force application all rc: %RC%" 

rem terminate is just a precaution prior to drop.
db2 terminate
set RC=%ERRORLEVEL%
echo "Terminate returned rc: %RC%" 


rem Drop should now ALWAYS report db not found.    
db2 drop database uddi20
set RC=%ERRORLEVEL%
echo "Drop database returned rc: %RC%"



rem CREATE NEW DATABASE
                     
db2 create database uddi20 using codeset UTF-8 territory en
set RC=%ERRORLEVEL%
echo "Create database returned rc: %RC%"
if %RC% GTR 0 ( goto BADEXIT )

@echo db2 connect to uddi20 user %2 using ******
@db2 connect to uddi20 user %2 using %3
set RC=%ERRORLEVEL%
echo "Authorised connect returned rc: %RC%"
if %RC% GTR 0 ( goto BADEXIT )

    
rem CONFIGURE NEW DATABASE

rem Call the db2 update cmd, and accept rc=0 or SQL1363W as ok.
db2 update db cfg for uddi20 using applheapsz 2048 > %1\udcahs.log 2>&1
set RC=%ERRORLEVEL%
@echo "Update applheapsz rc: %RC%" 

@echo "--Inserted udcahs.log--" 
type %1\udcahs.log 
@echo "--End Inserted udcahs.log--" 

rem check for mustrestart warning
@echo "Using %SYSTEMROOT%\system32\find.exe to find SQL1363W in udcahs.log" 
%SYSTEMROOT%\system32\find.exe "SQL1363W" %1\udcahs.log 
set FINDRC=%ERRORLEVEL%
@echo "FINDRC was %FINDRC%" 

@echo "Removing udcahs.log" 
del %1\udcahs.log

rem rc of 0 is good, rc of non zero is bad if we DONT find SQL1363W
if %RC% GTR 0 if %FINDRC% NEQ 0 goto BADEXIT


rem Call the db2 update cmd, and accept rc=0 or SQL1363W as ok.
db2 update db cfg for uddi20 using logfilsiz 8192 > %1\udclfs.log 2>&1
set RC=%ERRORLEVEL%
@echo "Update logfilesz returned rc: %RC%" 

@echo "--Inserted udclfs.log--" 
type %1\udclfs.log 
@echo "--End Inserted udclfs.log--" 

rem check for mustrestart warning
@echo "Using %SYSTEMROOT%\system32\find.exe to find SQL1363W in udclfs.log" 
%SYSTEMROOT%\system32\find.exe "SQL1363W" %1\udclfs.log 
set FINDRC=%ERRORLEVEL%
@echo "FINDRC was %FINDRC%" 

@echo "Removing udclfs.log" 
del %1\udclfs.log

rem rc of 0 is good, rc of non zero is bad if we DONT find SQL1363W
if %RC% GTR 0 if %FINDRC% NEQ 0 goto BADEXIT


rem ACTIVATE NEW CONFIGURATION

db2 connect reset
set RC=%ERRORLEVEL%
echo "Connect reset returned rc: %RC%" 
if %RC% GTR 0 ( goto BADEXIT )

db2 terminate
set RC=%ERRORLEVEL%
echo "Terminate returned rc: %RC%" 
if %RC% GTR 0 ( goto BADEXIT )

@echo db2 connect to uddi20 user %2 using ******
@db2 connect to uddi20 user %2 using %3
set RC=%ERRORLEVEL%
echo "Authorised connect returned rc: %RC%" 
if %RC% GTR 0 ( goto BADEXIT )


rem IMPORT DATA TO NEW DATABASE

db2 -tvf %1\uddicrt.sql
set RC=%ERRORLEVEL%
echo "Import of uddicrt.sql returned rc: %RC%" 
rem if %RC% GTR 0 ( goto BADEXIT )

db2 -tvf %1\uddiloadbasetmodels.sql
set RC=%ERRORLEVEL%
echo "Import of uddiloadbasetmodels.sql returned rc: %RC%" 
rem if %RC% GTR 0 ( goto BADEXIT )

call %1\populateCatTable %1
set RC=%ERRORLEVEL%
echo "call to populateCatTable returned rc: %RC%" 
if %RC% GTR 0 ( goto BADEXIT )


rem CLOSE CONNECTIONS TO DATABASE

db2 connect reset
set RC=%ERRORLEVEL%
echo "Connect reset returned rc: %RC%" 
if %RC% GTR 0 ( goto BADEXIT )

db2 terminate
set RC=%ERRORLEVEL%
echo "Terminate returned rc: %RC%" 
if %RC% GTR 0 ( goto BADEXIT )

rem If we got this far, we now jump to the good exit point
goto GOODEXIT




:GOODEXIT
echo "Exiting script with good ret code" 
endlocal
goto ALLDONE

:BADEXIT
echo "Exiting script with error ret code"
endlocal
rem use exit if OS supports it
VER | find "2000" > nul 
IF not errorlevel 1 exit 1
VER | find "XP" > nul 
IF not errorlevel 1 exit 1
rem default if OS/shell not recognised
verify other 2 > NUL 2>&1

:ALLDONE

